/*
	File: CBASE64.H
	Description:
		Implements a MIME BASE64 encoder/decoder.
	Copyright 1995, David G. Roberts
*/

#ifndef _CBASE64_H
#define _CBASE64_H

#include <windows.h>

typedef unsigned char uchar;

class CBase64Enc {
private:
	HFILE	m_hfile;
	uchar	m_uchBuffer[51];	// Must be multiple of 3.
public:
	enum { RESULT_OK, RESULT_ERROR, RESULT_DONE, RESULT_SMALLBUFFER };

	CBase64Enc() : m_hfile(NULL) {};
	virtual ~CBase64Enc()
		{ if (m_hfile != NULL) _lclose(m_hfile); };

	int OpenFile(char * pszFileName);
	int EncodeLine(char * pszLine, int nLen);
};

class CBase64Dec {
private:
	HFILE	m_hfile;
	uchar	m_uchStoredChars[4];
	int		m_iChars;
public:
	enum { RESULT_OK = 0, RESULT_ERROR = -1 };

	CBase64Dec() : m_hfile(NULL), m_iChars(0) {};
	virtual ~CBase64Dec()
		{ if (m_hfile != NULL) _lclose(m_hfile); };

	int OpenFile(char * pszFileName);
    int DecodeLine(char * pszLine, int nLineLen);
	int DecodeLine(char * pszLine, int nLineLen,
		uchar * uchBuffer, int nBufferLen);
};


#endif

