/*
	File: CHOST.H
	Description:
		A class to perform host name lookup.
	Copyright 1995, David G. Roberts
*/

#ifndef _CHOST_H
#define _CHOST_H

#include <windows.h>
#include "winsock.h"
#ifndef _CWINSOCK_H
#include "cwinsock.h"
#endif
#ifndef _CSOCKADR_H
#include "csockadr.h"
#endif
#ifndef _CASYNCDB_H
#include "casyncdb.h"
#endif

/*
	Class: CHost
	Description:
		CHost is used to look up host names and determine their
		addresses.
*/
class CHost : public CAsyncDB {
private:
	int		m_iAddrIndex;
	LPCSTR	m_lpszHostName;

	// Override the CAsyncDB member to start the async lookup specific
	// to CHost.
    virtual HANDLE StartWinsockLookup(void);

	// Hide this stuff so the compiler doesn't generate default
	// versions of them and nobody can use them by mistake.
	CHost(CHost&);		// Copy constructor
	operator=(CHost&);	// Assignment operator.
public:
	CHost(void)
		: CAsyncDB(), m_iAddrIndex(0) {};
	CHost(LPCSTR lpszHostName, CAsyncDBCallback * pCallback,
		int iToken) : CAsyncDB(), m_iAddrIndex(0)
		{ StartLookup(lpszHostName, pCallback, iToken); };
	~CHost() {};
	int StartLookup(LPCSTR lpszHostName, CAsyncDBCallback * pCallback,
		int iToken)
		{ m_lpszHostName = lpszHostName;
		return CAsyncDB::StartLookup(pCallback, iToken); };
	CSockAddr FirstAddr(BOOL *);
	CSockAddr NextAddr(BOOL *);
};

#endif
