/*
	File: CSERVICE.CPP
	Description:
		A class to perform serice lookup.
	Copyright 1995, David G. Roberts
*/

#include "cservice.h"
#include "myassert.h"

/*
	Function: CService::StartWinsockLookup
	Description:
		Handle the callback from CAsyncDB to start the asynchronous
		database function.
*/
HANDLE CService::StartWinsockLookup(void)
{
	// Simply kick of an asynchronous getservbyname operation.
	return WSAAsyncGetServByName(GetEventWindow(),
		WM_WSAGETHOSTBYNAME, m_lpszServiceName, m_lpszProtoName,
		(char FAR *) m_pBuffer, MAXGETHOSTSTRUCT);
}

/*
	Function: CService::Port
	Description:
		Get the port number of the service once it has been
		looked up.  Note that the function returns the port number
        in host byte order, suitable for passing to CSockAddr.
*/
u_short CService::Port(void)
{
	if (m_stState != VALID)
		return 0;
	return ntohs(((SERVENT *)m_pBuffer)->s_port);
}

