/*
	File: CSERVICE.H
	Description:
		A class to perform service lookup.
	Copyright 1995, David G. Roberts
*/

#ifndef _CSERVICE_H
#define _CSERVICE_H

#include <windows.h>
#include <winsock.h>
#ifndef _CWINSOCK_H
#include "cwinsock.h"
#endif
#ifndef _CSOCKADR_H
#include "csockadr.h"
#endif
#ifndef _CASYNCDB_H
#include "casyncdb.h"
#endif

/*
	Class: CService
	Description:
		CService is used to look up host names and determine their
		addresses.
*/
class CService : public CAsyncDB {
private:
	LPCSTR	m_lpszServiceName;
	LPCSTR	m_lpszProtoName;

	// Override the CAsyncDB member to start the async lookup
	// specific to CService.
    virtual HANDLE StartWinsockLookup(void);

	// Hide this stuff so the compiler doesn't generate default
	// versions of them and nobody can use them by mistake.
	CService(CService&);	// Copy constructor
	operator=(CService&);	// Assignment operator.
public:
	CService(void) : CAsyncDB() {};
	CService(LPCSTR lpszServiceName, LPCSTR lpszProtoName,
		CAsyncDBCallback * pCallback, int iToken)
		: CAsyncDB()
		{ StartLookup(lpszServiceName, lpszProtoName, pCallback,
		  iToken); };
	virtual ~CService() {};
	int StartLookup(LPCSTR lpszServiceName, LPCSTR lpszProtoName,
		CAsyncDBCallback * pCallback, int iToken)
		{ m_lpszServiceName = lpszServiceName;
        m_lpszProtoName = lpszProtoName;
		return CAsyncDB::StartLookup(pCallback, iToken); };
	u_short Port(void);
};

#endif
