/*
	File: CSOCKADR.CPP
	Description:
		An Internet family socket address class.
	Copyright 1995, David G. Roberts
*/

#include "csockadr.h"

/*
	Function: CSockAddr::operator=
	Description:
		Handle assignment operator.
*/
const CSockAddr& CSockAddr::operator=(const CSockAddr& csaSockAddr)
{
	if (&csaSockAddr != this) {
    	// Copy the structure.
		m_sinAddr = csaSockAddr.m_sinAddr;
	}
	return *this;
}

/*
	Function: CSockAddr::Set
	Description:
		Set the port and address info to the specified values.
		The port and address values are specified in host byte
		order in the parameter list and are converted by the
		function.
*/
void CSockAddr::Set(const u_short ushPort, const u_long ulAddr)
{
	m_sinAddr.sin_family		= AF_INET;
	m_sinAddr.sin_port			= htons(ushPort);
	m_sinAddr.sin_addr.s_addr	= htonl(ulAddr);
}

