/*
File: tracer.h
Description: Header file for general purpose tracing object.
History:
	March 1997, Dave Roberts, First written

Copyright 1997, David G. Roberts
*/

#include "tracer.h"

Tracer * Tracer::Instance(void)
{
	if (m_instance == NULL) {
		m_instance = new Tracer();
	}
	return m_instance;
}

unsigned Tracer::SetFlags(unsigned flags)
{
	unsigned temp = m_flags;
	m_flags |= flags;
	return temp;
}

unsigned Tracer::ClearFlags(unsigned flags)
{
	unsigned temp = m_flags;
	m_flags &= ~flags;
	return temp;
}

unsigned Tracer::AssignFlags(unsigned flags)
{
	unsigned temp = m_flags;
	m_flags = flags;
	return temp;
}

unsigned Tracer::GetFlags(void) const
{
	return m_flags;
}

Tracer::Tracer() : m_flags(DEFAULT_FLAGS), m_level(0)
{
	// Null body.
}

Tracer * Tracer::m_instance = NULL;


int Tracer::GetLevel(void) const
{
	return m_level;
}

int Tracer::SetLevel(int level)
{
	int temp = m_level;
	m_level = level;
	return temp;
}

int Tracer::IncrementLevel(void)
{
	return m_level++;
}

int Tracer::DecrementLevel(void)
{
	return m_level--;
}