/*
	File: MAILCLIG.H
	Description:
		The global variable declarations for MAILCLI.
	Copyright 1995, David G. Roberts
*/

#ifdef DECLARE
#define INIT(x)
#define EXTERN extern
#else
#define INIT(x) x
#define EXTERN
#endif

/*
	CONSTANTS
*/
#define MAX_PATH_LENGTH		260
#define MAX_FILENAME_LENGTH	255

/*
	MACROS
*/
// Microsoft Visual C++ 1.5 WINDOWSX.H doesn't include these macros
// like Borland does.
#ifndef GET_WM_COMMAND_ID
#ifdef WIN32
#define GET_WM_COMMAND_ID(wp, lp)	LOWORD(wp)
#else
#define GET_WM_COMMAND_ID(wp, lp)	(wp)
#endif
#endif

#ifndef GET_WM_COMMAND_HWND
#ifdef WIN32
#define GET_WM_COMMAND_HWND(wp, lp)		(HWND)(lp)
#else
#define GET_WM_COMMAND_HWND(wp, lp)		(HWND)LOWORD(lp)
#endif
#endif

#ifndef GET_WM_COMMAND_CMD
#ifdef WIN32
#define GET_WM_COMMAND_CMD(wp, lp)		HIWORD(wp)
#else
#define GET_WM_COMMAND_CMD(wp, lp)		HIWORD(lp)
#endif
#endif

#ifndef GET_WM_COMMAND_MPS
#ifdef WIN32
#define GET_WM_COMMAND_MPS(id, hwnd, cmd)    \
		(WPARAM)MAKELONG(id, cmd), (LONG)(hwnd)
#else
#define GET_WM_COMMAND_MPS(id, hwnd, cmd)    \
		(WPARAM)(id), MAKELONG(hwnd, cmd)
#endif
#endif

#ifndef GET_WM_MDISETMENU_MPS
#ifdef WIN32
#define GET_WM_MDISETMENU_MPS(hmenuF, hmenuW) (WPARAM)hmenuF, (LONG)hmenuW
#else
#define GET_WM_MDISETMENU_MPS(hmenuF, hmenuW) 0, MAKELONG(hmenuF, hmenuW)
#endif
#endif

#ifndef GET_EM_SETSEL_MPS
#ifdef WIN32
#define GET_EM_SETSEL_MPS(iStart, iEnd) \
        (WPARAM)(iStart), (LONG)(iEnd)
#else
#define GET_EM_SETSEL_MPS(iStart, iEnd) \
        0, MAKELONG(iStart, iEnd)
#endif
#endif

/*
	GLOBAL VARIABLES
*/
#ifdef WIN32
#define WINVERSION "32"
#else
#define WINVERSION "16"
#endif
EXTERN HWND			g_hFrame;
EXTERN HWND			g_hClient;
EXTERN HINSTANCE	g_hInstance;
EXTERN char			g_szAppName[] INIT(= "MAILCLI");
EXTERN char			g_szFullAppName[]
						INIT(= "Mail Client (Win" WINVERSION ")");
EXTERN char			g_szFrameClass[] INIT(= "MAILCLIFRAME");
EXTERN char			g_szMailboxClass[] INIT(= "MAILBOXCHILD");
EXTERN char			g_szViewerClass[] INIT(= "VIEWERCHILD");
EXTERN char			g_szEditorClass[] INIT(= "EDITORCHILD");
EXTERN HMENU		g_hFrameMenu;
EXTERN HMENU		g_hMailboxMenu;
EXTERN HMENU		g_hViewerMenu;
EXTERN HMENU		g_hEditorMenu;
EXTERN HMENU		g_hFrameWindowMenu;
EXTERN HMENU		g_hMailboxWindowMenu;
EXTERN HMENU		g_hViewerWindowMenu;
EXTERN HMENU		g_hEditorWindowMenu;
EXTERN HACCEL		g_hAccel;
EXTERN char *		g_pszSMTPServer;
EXTERN u_short		g_ushSMTPPort;
EXTERN u_short		g_ushSMTPDefaultPort;
EXTERN char *		g_pszPOPServer;
EXTERN u_short		g_ushPOPPort;
EXTERN u_short		g_ushPOPDefaultPort;
EXTERN char *		g_pszMailbox;
EXTERN char *		g_pszPassword;
EXTERN char *		g_pszUserName;
EXTERN char *		g_pszUserAddress;
EXTERN char			g_szIniFile[] INIT(= "mailcli.ini");
EXTERN char *		g_pszWorkingDirectory;
EXTERN CWinsock		g_wsWinsock INIT((0x0101, 0x0101));
EXTERN BOOL			g_bConfigured INIT(= FALSE);
EXTERN char			g_szMessageDir[MAX_PATH_LENGTH];
EXTERN char			g_szMailboxFile[MAX_PATH_LENGTH];

/*
	GLOBAL FUNCTIONS
*/
void ForwardDefFrameProc(HWND, UINT, WPARAM, LPARAM);
HWND GetMDIActiveChild(HWND);
BOOL VerifyDlgInt(HWND, int, BOOL);
BOOL VerifyDlgText(HWND, int);
void SetEditErrorFocus(HWND, int);


