/*
	File: NEWSCLIG.H
	Description:
		The global variable declarations for NEWSCLI.
	Copyright 1995, David G. Roberts
*/

#ifdef DECLARE
#define INIT(x)
#define EXTERN extern
#else
#define INIT(x) x
#define EXTERN
#endif

/*
	CONSTANTS
*/
#define MAX_PATH_LENGTH		260
#define MAX_FILENAME_LENGTH	255

/*
	MACROS
*/
// Microsoft Visual C++ 1.5 WINDOWSX.H doesn't include these macros
// like Borland does.
#ifndef GET_WM_COMMAND_ID
#ifdef WIN32
#define GET_WM_COMMAND_ID(wp, lp)	LOWORD(wp)
#else
#define GET_WM_COMMAND_ID(wp, lp)	(wp)
#endif
#endif

#ifndef GET_WM_COMMAND_HWND
#ifdef WIN32
#define GET_WM_COMMAND_HWND(wp, lp)		(HWND)(lp)
#else
#define GET_WM_COMMAND_HWND(wp, lp)		(HWND)LOWORD(lp)
#endif
#endif

#ifndef GET_WM_COMMAND_CMD
#ifdef WIN32
#define GET_WM_COMMAND_CMD(wp, lp)		HIWORD(wp)
#else
#define GET_WM_COMMAND_CMD(wp, lp)		HIWORD(lp)
#endif
#endif

#ifndef GET_WM_COMMAND_MPS
#ifdef WIN32
#define GET_WM_COMMAND_MPS(id, hwnd, cmd)    \
		(WPARAM)MAKELONG(id, cmd), (LONG)(hwnd)
#else
#define GET_WM_COMMAND_MPS(id, hwnd, cmd)    \
		(WPARAM)(id), MAKELONG(hwnd, cmd)
#endif
#endif

#ifndef GET_WM_MDISETMENU_MPS
#ifdef WIN32
#define GET_WM_MDISETMENU_MPS(hmenuF, hmenuW) (WPARAM)hmenuF, (LONG)hmenuW
#else
#define GET_WM_MDISETMENU_MPS(hmenuF, hmenuW) 0, MAKELONG(hmenuF, hmenuW)
#endif
#endif

#ifndef GET_EM_SETSEL_MPS
#ifdef WIN32
#define GET_EM_SETSEL_MPS(iStart, iEnd) \
        (WPARAM)(iStart), (LONG)(iEnd)
#else
#define GET_EM_SETSEL_MPS(iStart, iEnd) \
        0, MAKELONG(iStart, iEnd)
#endif
#endif

/*
	TYPES
*/
struct GROUPANDARTICLE {
	char *		pszGroupName;
	long		lArticleNum;
};

/*
	GLOBAL VARIABLES
*/
#ifdef WIN32
#define WINVERSION "32"
#else
#define WINVERSION "16"
#endif
EXTERN HWND			g_hFrame;
EXTERN HWND			g_hClient;
EXTERN HINSTANCE	g_hInstance;
EXTERN char			g_szAppName[] INIT(= "NEWSCLI");
EXTERN char			g_szFullAppName[]
						INIT(= "News Client (Win" WINVERSION ")");
EXTERN char			g_szFrameClass[] INIT(= "NEWSCLIFRAME");
EXTERN char			g_szGroupClass[] INIT(= "GROUPCHILD");
EXTERN char			g_szArticleClass[] INIT(= "ARTICLECHILD");
EXTERN HMENU		g_hFrameMenu;
EXTERN HMENU		g_hGroupMenu;
EXTERN HMENU		g_hArticleMenu;
EXTERN HMENU		g_hFrameWindowMenu;
EXTERN HMENU		g_hGroupWindowMenu;
EXTERN HMENU		g_hArticleWindowMenu;
EXTERN HACCEL		g_hAccel;
EXTERN char *		g_pszNNTPServer;
EXTERN u_short		g_ushNNTPPort;
EXTERN u_short		g_ushNNTPDefaultPort;
EXTERN char *		g_pszGroup;
EXTERN char			g_szIniFile[] INIT(= "newscli.ini");
EXTERN char *		g_pszWorkingDirectory;
EXTERN CWinsock		g_wsWinsock INIT((0x0101, 0x0101));
EXTERN BOOL			g_bConfigured INIT(= FALSE);

/*
	GLOBAL FUNCTIONS
*/
void ForwardDefFrameProc(HWND, UINT, WPARAM, LPARAM);
HWND GetMDIActiveChild(HWND);
BOOL VerifyDlgInt(HWND, int, BOOL);
BOOL VerifyDlgText(HWND, int);
void SetEditErrorFocus(HWND, int);


